package com.logicbig.example;

import javax.annotation.Priority;
import javax.ws.rs.container.ContainerRequestContext;
import javax.ws.rs.container.ContainerRequestFilter;
import javax.ws.rs.core.CacheControl;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.ext.Provider;
import java.io.IOException;

@Priority(1)
@Provider
public class InvalidRequestFilter implements ContainerRequestFilter {

    @Override
    public void filter(ContainerRequestContext reqContext) throws IOException {
        Response responseForInvalidRequest = validateRequest(reqContext);
        if (responseForInvalidRequest != null) {
            reqContext.abortWith(responseForInvalidRequest);
        }
    }

    private Response validateRequest(ContainerRequestContext reqContext) {
        UriInfo uriInfo = reqContext.getUriInfo();
        String path = uriInfo.getPath();
        if (path.equals("orders/history")) {
            String msg = String.format("The feature is not yet supported: %s%n", path);
            CacheControl cc = new CacheControl();
            cc.setNoStore(true);
            Response response = Response.status(Response.Status.NOT_IMPLEMENTED)
                                        .cacheControl(cc)
                                        .entity(msg)
                                        .build();
            return response;
        }
        return null;
    }
}